FunctionCurve Class Reference

`#include <FunctionCurve.h>`

Inheritance diagram for FunctionCurve:

## Public Types

enum | FunctionType { Normal = 0, Parametric = 1, Polar = 2 }

## Public Member Functions

QMap< QString, double > | constants ()
void | copy (FunctionCurve *f)
double | endRange ()
QStringList | formulas ()
| FunctionCurve (const FunctionType &t, const QString &name=QString())
| FunctionCurve (const QString &name=QString())
FunctionType | functionType ()
QString | legend ()
| Returns a string that can be displayed in a plot legend. More...
bool | loadData (int points=0, bool xLog10Scale=false)
QString | parameterName (int index)
| Returns the name of the parameter of rang index. More...
int | parametersCount ()
| Returns the number of parameters in your function formula. More...
double | parameterValue (int index)
| Returns the value of the parameter of rang index. More...
double | parameterValue (const QString &name)
| Returns the value of the name parameter. More...
void | removeConstant (const QString &parName)
void | removeConstants ()
QString | saveToString ()
| Returns a string used when saving to a project file. More...
void | setConstant (const QString &parName, double val)
void | setConstants (const QMap< QString, double > &map)
void | setFormula (const QString &s)
| Provided for convenience when dealing with normal functions. More...
void | setFormulas (const QStringList &lst)
void | setFunctionType (const FunctionType &t)
void | setRange (double from, double to)
void | setVariable (const QString &s)
double | startRange ()
QString | variable ()
Public Member Functions inherited from PlotCurve
void | enableSideLines (bool on)
| PlotCurve (const QString &name=QString())
int | plotStyle ()
| The plot style of the curve. More...
void | restoreCurveLayout (const QStringList &lst)
QString | saveCurveLayout ()
QString | saveCurveSymbolImage ()
void | setPlotStyle (int s)
void | setSkipSymbolsCount (int count)
| Set the number of symbols not to be drawn: usefull for large data sets. More...
void | setType (int t)
void | setXOffset (double dx)
void | setYOffset (double dy)
bool | sideLinesEnabled ()
int | skipSymbolsCount ()
| Returns the number of symbols not to be drawn. More...
int | type ()
| Sort of rtti() More...
double | xOffset ()
double | yOffset ()

## Static Public Member Functions

static void | restore (Graph *g, const QStringList &lst)
| Used when reading from a project file. More...

## Private Attributes

QMap< QString, double > | d_constants
QStringList | d_formulas
double | d_from
FunctionType | d_function_type
double | d_to
QString | d_variable

## Additional Inherited Members

Protected Member Functions inherited from PlotCurve
QwtDoubleRect | boundingRect () const
virtual void | drawCurve (QPainter *p, int style, const QwtScaleMap &xMap, const QwtScaleMap &yMap, int from, int to) const
void | drawSideLines (QPainter *p, const QwtScaleMap &xMap, const QwtScaleMap &yMap, int from, int to) const
void | drawSticks (QPainter *p, const QwtScaleMap &xMap, const QwtScaleMap &yMap, int from, int to) const
virtual void | drawSymbols (QPainter *p, const QwtSymbol &, const QwtScaleMap &xMap, const QwtScaleMap &yMap, int from, int to) const
| Draw symbols. More...
Protected Attributes inherited from PlotCurve
int | d_plot_style
bool | d_side_lines
int | d_skip_symbols
int | d_type
double | d_x_offset
double | d_y_offset

## Member Enumeration Documentation

enum FunctionCurve::FunctionType

Enumerator
Normal |
Parametric |
Polar |

## Constructor & Destructor Documentation

FunctionCurve::FunctionCurve | ( | const FunctionType & | t,
|  | const QString & | name = `QString()`
| ) |  |

References Graph::Function, Graph::Line, PlotCurve::setPlotStyle(), and PlotCurve::setType().

Referenced by restore().

FunctionCurve::FunctionCurve | ( | const QString & | name = `QString()` | ) |

References d_formulas, Graph::Function, Graph::Line, PlotCurve::setPlotStyle(), and PlotCurve::setType().

## Member Function Documentation

QMap<QString, double> FunctionCurve::constants | ( |  | ) |

inline

References d_constants.

Referenced by copy(), Graph::modifyFunctionCurve(), restore(), FunctionDialog::setCurveToModify(), and FitDialog::updatePreview().

void FunctionCurve::copy | ( | FunctionCurve * | f | ) |

References constants(), d_constants, d_formulas, d_from, d_function_type, d_to, d_variable, endRange(), formulas(), functionType(), startRange(), and variable().

double FunctionCurve::endRange | ( |  | ) |

inline

References d_to.

Referenced by copy(), Graph::modifyFunctionCurve(), FunctionDialog::setCurveToModify(), and FitDialog::updatePreview().

QStringList FunctionCurve::formulas | ( |  | ) |

inline

References d_formulas.

Referenced by copy(), Graph::modifyFunctionCurve(), restore(), TranslateCurveTool::selectDestination(), FunctionDialog::setCurveToModify(), and FitDialog::updatePreview().

FunctionType FunctionCurve::functionType | ( |  | ) |

inline

References d_function_type.

Referenced by copy(), Graph::modifyFunctionCurve(), TranslateCurveTool::selectDestination(), and FunctionDialog::setCurveToModify().

QString FunctionCurve::legend | ( |  | ) |

Returns a string that can be displayed in a plot legend.

References d_formulas, d_function_type, d_variable, Normal, Parametric, and Polar.

Referenced by Graph::modifyFunctionCurve().

bool FunctionCurve::loadData | ( | int | points = `0`,
|  | bool | xLog10Scale = `false`
| ) |  |

References d_constants, d_formulas, d_from, d_function_type, d_to, d_variable, MyParser::EvalRemoveSingularity(), ScaleTransformation::Log10, Normal, Parametric, Polar, and ScaleEngine::type().

Referenced by Graph::addFunction(), NonLinearFit::insertFitFunctionCurve(), Fit::insertFitFunctionCurve(), MultiPeakFit::insertPeakFunctionCurve(), Graph::modifyFunctionCurve(), restore(), TranslateCurveTool::selectDestination(), FunctionDialog::setConstants(), AxesDialog::updateMinorTicksList(), and FitDialog::updatePreview().

QString FunctionCurve::parameterName | ( | int | index | ) |

Returns the name of the parameter of rang index.

References d_constants.

int FunctionCurve::parametersCount | ( |  | ) |

inline

Returns the number of parameters in your function formula.

References d_constants.

double FunctionCurve::parameterValue | ( | int | index | ) |

Returns the value of the parameter of rang index.

References d_constants.

double FunctionCurve::parameterValue | ( | const QString & | name | ) |

Returns the value of the name parameter.

References d_constants.

void FunctionCurve::removeConstant | ( | const QString & | parName | ) |

inline

References d_constants.

void FunctionCurve::removeConstants | ( |  | ) |

inline

References d_constants.

Referenced by FitDialog::updatePreview().

void FunctionCurve::restore | ( | Graph * | g,
|  | const QStringList & | lst
| ) |  |

static

Used when reading from a project file.

References constants(), Graph::curveIndex(), formulas(), FunctionCurve(), Graph::insertCurve(), loadData(), PlotCurve::restoreCurveLayout(), setConstants(), Graph::setCurveStyle(), setFormulas(), PlotCurve::setPlotStyle(), setRange(), setVariable(), PlotCurve::type(), and Graph::updatePlot().

Referenced by ApplicationWindow::openGraph().

QString FunctionCurve::saveToString | ( |  | ) |

Returns a string used when saving to a project file.

References d_constants, d_formulas, d_from, d_function_type, d_to, d_variable, ScaleTransformation::Log10, PlotCurve::saveCurveLayout(), PlotCurve::saveCurveSymbolImage(), and ScaleEngine::type().

void FunctionCurve::setConstant | ( | const QString & | parName,
|  | double | val
| ) |  |

inline

References d_constants.

Referenced by NonLinearFit::insertFitFunctionCurve(), Fit::insertFitFunctionCurve(), MultiPeakFit::insertPeakFunctionCurve(), and FitDialog::updatePreview().

void FunctionCurve::setConstants | ( | const QMap< QString, double > & | map | ) |

inline

References d_constants.

Referenced by Graph::modifyFunctionCurve(), restore(), and FunctionDialog::setConstants().

void FunctionCurve::setFormula | ( | const QString & | s | ) |

inline

Provided for convenience when dealing with normal functions.

References d_formulas.

Referenced by Fit::insertFitFunctionCurve(), MultiPeakFit::insertPeakFunctionCurve(), TranslateCurveTool::selectDestination(), and FitDialog::updatePreview().

void FunctionCurve::setFormulas | ( | const QStringList & | lst | ) |

inline

References d_formulas.

Referenced by Graph::addFunction(), Graph::modifyFunctionCurve(), and restore().

void FunctionCurve::setFunctionType | ( | const FunctionType & | t | ) |

inline

References d_function_type.

Referenced by Graph::modifyFunctionCurve().

void FunctionCurve::setRange | ( | double | from,
|  | double | to
| ) |  |

References d_from, and d_to.

Referenced by Graph::addFunction(), Fit::insertFitFunctionCurve(), MultiPeakFit::insertPeakFunctionCurve(), Graph::modifyFunctionCurve(), restore(), and FitDialog::updatePreview().

void FunctionCurve::setVariable | ( | const QString & | s | ) |

inline

References d_variable.

Referenced by Graph::addFunction(), Graph::modifyFunctionCurve(), and restore().

double FunctionCurve::startRange | ( |  | ) |

inline

References d_from.

Referenced by copy(), Graph::modifyFunctionCurve(), FunctionDialog::setCurveToModify(), and FitDialog::updatePreview().

QString FunctionCurve::variable | ( |  | ) |

inline

References d_variable.

Referenced by copy(), Graph::modifyFunctionCurve(), and FunctionDialog::setCurveToModify().

## Member Data Documentation

QMap<QString, double> FunctionCurve::d_constants

private

Referenced by constants(), copy(), loadData(), parameterName(), parametersCount(), parameterValue(), removeConstant(), removeConstants(), saveToString(), setConstant(), and setConstants().

QStringList FunctionCurve::d_formulas

private

Referenced by copy(), formulas(), FunctionCurve(), legend(), loadData(), saveToString(), setFormula(), and setFormulas().

double FunctionCurve::d_from

private

Referenced by copy(), loadData(), saveToString(), setRange(), and startRange().

FunctionType FunctionCurve::d_function_type

private

Referenced by copy(), functionType(), legend(), loadData(), saveToString(), and setFunctionType().

double FunctionCurve::d_to

private

Referenced by copy(), endRange(), loadData(), saveToString(), and setRange().

QString FunctionCurve::d_variable

private

Referenced by copy(), legend(), loadData(), saveToString(), setVariable(), and variable().

The documentation for this class was generated from the following files:

- qtiplot/src/plot2D/FunctionCurve.h
- qtiplot/src/plot2D/FunctionCurve.cpp